"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var enzyme_1 = require("enzyme");
var react_1 = __importDefault(require("react"));
var ts_mockito_1 = require("ts-mockito");
var testUtils_1 = require("../../testUtils");
var dataHOC_1 = require("./dataHOC");
describe("Auto URL data sync", function () {
    var initial = { a: 0, b: 0, c: 0 };
    var additionalDataQuery = { a: 1, b: 2, c: 3 };
    var TestComponent = testUtils_1.createTestComponent();
    var EnhancedComponent = dataHOC_1.urlDataSync()(TestComponent);
    var urlDataSync;
    var WrappedElement;
    var onDataChange;
    beforeEach(function () {
        onDataChange = jest.fn();
        urlDataSync = ts_mockito_1.spy({
            get: function () { return Promise.reject(""); },
            update: function () { return Promise.reject(""); },
            updateURLQuery: function () { return Promise.reject(""); },
            getURLQuery: function () { return Promise.reject(""); }
        });
        WrappedElement = (react_1.default.createElement(EnhancedComponent, { additionalDataQuery: additionalDataQuery, initialData: initial, onDataChange: onDataChange, urlDataSync: ts_mockito_1.instance(urlDataSync) }));
    });
    it("Should perform get automatically", function () { return __awaiter(_this, void 0, void 0, function () {
        var data, query, wrapper, _a, result, isLoadingData, urlQuery;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    data = { a: 0, b: 1, c: 2 };
                    query = { a: "1", b: "2" };
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve(data);
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve(query);
                    wrapper = enzyme_1.mount(WrappedElement);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _b.sent();
                    wrapper.setProps({});
                    _a = wrapper
                        .find(TestComponent)
                        .props(), result = _a.data, isLoadingData = _a.isLoadingData, urlQuery = _a.urlQuery;
                    // Then
                    ts_mockito_1.verify(urlDataSync.get(ts_mockito_1.deepEqual(additionalDataQuery))).once();
                    ts_mockito_1.verify(urlDataSync.getURLQuery()).once();
                    expect(onDataChange).toHaveBeenCalledTimes(1);
                    expect(isLoadingData).toBeFalsy();
                    expect(result).toEqual(data);
                    expect(urlQuery).toEqual(query);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should perform save correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var data, newData, wrapper, updateData, saveData, loading1, _a, result, loading2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    data = { a: 0, b: 1, c: 2 };
                    newData = { a: 1, b: 2, c: 3 };
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve(data);
                    ts_mockito_1.when(urlDataSync.update(ts_mockito_1.anything())).thenResolve(newData);
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    wrapper = enzyme_1.mount(WrappedElement);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _b.sent();
                    wrapper.setProps({});
                    updateData = wrapper.find(TestComponent).props().updateData;
                    updateData(newData);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _b.sent();
                    wrapper.setProps({});
                    saveData = wrapper.find(TestComponent).props().saveData;
                    saveData();
                    wrapper.setProps({});
                    loading1 = wrapper.find(TestComponent).props().isLoadingData;
                    expect(loading1).toBeTruthy();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 3:
                    _b.sent();
                    wrapper.setProps({});
                    _a = wrapper
                        .find(TestComponent)
                        .props(), result = _a.data, loading2 = _a.isLoadingData;
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 4:
                    _b.sent();
                    // Then
                    ts_mockito_1.verify(urlDataSync.get(ts_mockito_1.deepEqual(additionalDataQuery))).once();
                    ts_mockito_1.verify(urlDataSync.update(ts_mockito_1.deepEqual(newData))).once();
                    expect(loading2).toBeFalsy();
                    expect(result).toEqual(newData);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should update URL queries correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var query, wrapper, updateURLQuery, urlQuery;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    // Setup
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve({});
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    ts_mockito_1.when(urlDataSync.updateURLQuery(ts_mockito_1.anything())).thenResolve(undefined);
                    query = { a: "1", b: "2" };
                    wrapper = enzyme_1.mount(WrappedElement);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _a.sent();
                    wrapper.setProps({});
                    updateURLQuery = wrapper.find(TestComponent).props().updateURLQuery;
                    updateURLQuery(query);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _a.sent();
                    wrapper.setProps({});
                    urlQuery = wrapper.find(TestComponent).props().urlQuery;
                    // Then
                    ts_mockito_1.verify(urlDataSync.get(ts_mockito_1.deepEqual(additionalDataQuery))).twice();
                    ts_mockito_1.verify(urlDataSync.getURLQuery()).once();
                    ts_mockito_1.verify(urlDataSync.updateURLQuery(ts_mockito_1.deepEqual(query)));
                    expect(urlQuery).toEqual(query);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should set error when getting data fails", function () { return __awaiter(_this, void 0, void 0, function () {
        var error, wrapper, dataError;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    error = new Error("error!");
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenReject(error);
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    wrapper = enzyme_1.mount(WrappedElement);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _a.sent();
                    wrapper.setProps({});
                    dataError = wrapper.find(TestComponent).props().dataError;
                    // Then
                    expect(dataError).toEqual(error);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Should set error when saving fails", function () { return __awaiter(_this, void 0, void 0, function () {
        var error, wrapper, saveData, dataError;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    error = new Error("error!");
                    ts_mockito_1.when(urlDataSync.get(ts_mockito_1.anything())).thenResolve({});
                    ts_mockito_1.when(urlDataSync.getURLQuery()).thenResolve({});
                    ts_mockito_1.when(urlDataSync.update(ts_mockito_1.anything())).thenReject(error);
                    wrapper = enzyme_1.mount(WrappedElement);
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 1:
                    _a.sent();
                    wrapper.setProps({});
                    saveData = wrapper.find(TestComponent).props().saveData;
                    saveData();
                    return [4 /*yield*/, testUtils_1.asyncTimeout(1)];
                case 2:
                    _a.sent();
                    wrapper.setProps({});
                    dataError = wrapper.find(TestComponent).props().dataError;
                    // Then
                    expect(dataError).toEqual(error);
                    return [2 /*return*/];
            }
        });
    }); });
});
describe("Cursor pagination", function () {
    var TestComponent = testUtils_1.createTestComponent(dataHOC_1.cursorPagination);
    var EnhancedComponent = dataHOC_1.cursorPagination()(TestComponent);
    var WrappedElement;
    beforeEach(function () {
        WrappedElement = react_1.default.createElement(EnhancedComponent, null);
    });
    it("Should set next correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        // Setup
        function createData(next, previous) {
            return {
                results: [],
                count: 0,
                limit: 0,
                next: next,
                previous: previous
            };
        }
        var wrapper, onChange1, _a, query1, page1, onChange2, _b, query2, page2, onChange3, _c, query3, page3, onChange4, _d, query4, page4;
        return __generator(this, function (_e) {
            wrapper = enzyme_1.mount(WrappedElement);
            onChange1 = wrapper.find(TestComponent).props().onDataChange;
            onChange1(createData("next1", "prev1"));
            wrapper.setProps({});
            _a = wrapper
                .find(TestComponent)
                .props(), query1 = _a.additionalDataQuery, page1 = _a.page;
            expect(query1).toEqual({ next: "next1", previous: "prev1" });
            expect(page1).toEqual(0);
            onChange2 = wrapper.find(TestComponent).props().onDataChange;
            onChange2(createData("next2", "next1"));
            wrapper.setProps({});
            _b = wrapper
                .find(TestComponent)
                .props(), query2 = _b.additionalDataQuery, page2 = _b.page;
            expect(query2).toEqual({ next: "next2", previous: "next1" });
            expect(page2).toEqual(1);
            onChange3 = wrapper.find(TestComponent).props().onDataChange;
            onChange3(createData("next1", "prev1"));
            wrapper.setProps({});
            _c = wrapper
                .find(TestComponent)
                .props(), query3 = _c.additionalDataQuery, page3 = _c.page;
            expect(query3).toEqual({ next: "next1", previous: "prev1" });
            expect(page3).toEqual(0);
            onChange4 = wrapper.find(TestComponent).props().onDataChange;
            onChange4(createData("prev1", "prev2"));
            wrapper.setProps({});
            _d = wrapper
                .find(TestComponent)
                .props(), query4 = _d.additionalDataQuery, page4 = _d.page;
            expect(query4).toEqual({ next: "prev1", previous: "prev2" });
            expect(page4).toEqual(0);
            return [2 /*return*/];
        });
    }); });
});
describe("Cursor pagination data", function () {
    var TestComponent = testUtils_1.createTestComponent(dataHOC_1.cursorPaginatedData);
    var EnhancedComponent = dataHOC_1.cursorPaginatedData()(TestComponent);
    it("Should create sparse data correctly", function () { return __awaiter(_this, void 0, void 0, function () {
        var paginated, WrappedElement, data1, data2;
        return __generator(this, function (_a) {
            paginated = { results: [1, 2], count: 4, limit: 2 };
            WrappedElement = react_1.default.createElement(EnhancedComponent, { data: paginated, page: 0 });
            data1 = enzyme_1.mount(WrappedElement)
                .find(TestComponent)
                .props().data;
            expect(data1).toEqual([1, 2, undefined, undefined]);
            // When && Then: Page 1.
            WrappedElement = react_1.default.createElement(EnhancedComponent, { data: paginated, page: 1 });
            data2 = enzyme_1.mount(WrappedElement)
                .find(TestComponent)
                .props().data;
            expect(data2).toEqual([undefined, undefined, 1, 2]);
            return [2 /*return*/];
        });
    }); });
});
